/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#include <vector>
#include <string>
#include <iostream>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"

#include "protein-geometry.hh"
#include "coot-utils.hh"
#include "restraints-editor.hh"

#include "graphics-info.h"


#define PACKAGE restraints-editor


void
show_restraints_editor(std::string monomer_type, std::string dir) {

   coot::protein_geometry pg;
   std::string f = "/home/paule/ccp4/ccp4-6.0/lib/data/monomers/";
   f += dir;
   f += "/";
   f += monomer_type;
   f += ".cif";
   
   pg.init_refmac_mon_lib(f, 0);
   std::pair<short int, coot::dictionary_residue_restraints_t> p =
     pg.get_monomer_restraints(monomer_type);
   
   if (p.first) { 
      coot::dictionary_residue_restraints_t restraints = p.second;
      
      coot::restraints_editor r;
      graphics_info_t g;
      r.fill_dialog(restraints);
      g.restraints_editors.push_back(r);
   }
}


int
main (int argc, char *argv[])
{
   GtkWidget *restraints_editor_dialog;
   
   gtk_set_locale ();
   gtk_init (&argc, &argv);
   
   // show_restraints_editor("ATP", "a");
   show_restraints_editor("PHE", "p");
   
   gtk_main();
   return 0;
}


